; ***************************************************************************
; *                                                                         *
; * Hitachi CDR-3600/1600S C D - R O M Device Driver                        *
; * Copyright reserved by Hitachi, Ltd.                                     *
; *                                                                         *
; * CD.INC                                                                  *
; *                                                                         *
; * Command codes for CDREAD().                                             *
; *                                                                         *
; *                                                                         *
; * History:                                                                *
; *                                                                         *
; * Created  (v2.20)                                                        *
; *     Fri Jun 22 1990  -by- Michael Edwards                               *
; *     Moved these device dependent definitions from MSCDEX21.INC.         *
; * Modified (v2.20)                                                        *
; *     10/1/90 -by- JohnYG                                                 *
; *     Final Release (v2.20)                                               *
; *                                                                         *
; ***************************************************************************


RESET_CMD               =        0h     ;Reset drive
READ_CMD                =        1h     ;Read disc data until completed
SEEK_CMD                =        2h     ;Seek to disc address
SEEKW_CMD               =        3h     ;Seek to disc address until completed
STATUS_CMD              =        4h     ;Get status
DRVSTS_CMD              =        5h     ;Get drive-status
READ_COOKED             =        6h     ;read bytes in cooked mode
READ_UCOM               =        7h     ;Get RAM of drive micro-chip
SEEK_LEADIN_CMD         =        8h     ;Seek to Lead-in track
READ_Q_CMD              =        9h     ;Read 10 subcode-Q bytes
PAUSE_CMD               =       0ah     ;Pause (use to Stop play)
AUDIO_CMD               =       0bh     ;Play audio
;                       =       0ch
AUDIO_L_R_CMD           =       0dh     ;Play audio w/channel control
AUDIO_TNO_CMD           =       0eh     ;Play audio w/channel control by TNO
OPENDOOR_CMD            =       0fh     ;Eject disc
CLOSEDOOR_CMD           =       10h     ;Load disc(not used)
PREVENT_ALLOW_CMD       =       11h     ;Lock/Unlock door
SET_POWER_SAVE          =       12h     ;SET POWER SAVE
;                       =       13h
AUDIO_CHANNEL_CTL       =       14h     ;Audio channel control
GET_DRIVE_VERSION       =       15h     ;VERSION
;                       =       16h
MODESET_CMD             =       17h     ;Mode set
;                               18h     ;reserved
;                               19h     ;reserved
READ_RAW                =       1ah     ;read bytes raw (2352)
;                               1b-ffh  ;reserved

;
; from cdread.at for init stuff moved to cdrom_init
;
;       < I/O >
TIMER_MODE      EQU     43H             ;8253 OR 8254
TIMER0          EQU     40H
IMR             EQU     21H             ;8259 (MASTER)
RETRY2          EQU     2       ;LIMIT OF ERROR RETRY FOR OTHER COMMAND
