// Syntax Error messages while parsing profile 
// used in setup.c

static char szRepKey[] = "Repeated Keyword";
static char szSpurCh[] = "Spurious Character";
static char szIllChar[] = "Illegal  Character";
static char szUnreck[] = "Unrecognized  Keyword";
static char szNodrname[] = "No Driver Name in Profile ";
static char szBadintlv[] = "Bad interleave values specified in profile";

/*
**  Table of labels mapping to flags
*/

#define NUM_VALS        17
static char *szLabelTable[NUM_VALS] = {
    "drivername",
    "writedevice",
    "redbook",
    "rawmode",
    "prefetch",
    "audiocontrol",
    "audio",
    "audiochannels",
    "interleave",
    "eject",
    "upc",
    "output",
    "redsectors",
    "hsgsectors",
    "interleaveskip",
    "interleavesize",
    "subinfo"

};

enum labels {laDRIVERNAME=0,laWRITEDEVICE,laREDBOOK,laRAWMODE,laPREFETCH,
    laAUDIOCNTRL,laAUDIOCAPABLE,laAUDIOCHANNELS,laINTERLEAVE,laEJECT,
    laUPCCODE,laOUTPUT,laREDSECTORS,laHSGSECTORS,laINTERSIZE,laINTERSKIP,
    laSUBINFO};


//
// Test functions
//    We'll use these with a menu based app sometime
//

static void (*mTestTbl[])(Dev_List *) = {
    TestInit,                               // tINIT
    TestDevStat,                            // tDEVSTAT
    TestRaddr,                              // tRADDR
    TestReset,                              // tRESET
    TestLockDoor,                           // tLOCKDOOR
    TestDrvBytes,                           // tDRVBYTES
    TestReservedCmd,                        // tRESERVEDCMD
    TestSectorSize,                         // tSECTORSIZE
    TestUPCCode,                            // tUPCCODE
    TestVolSize,                            // tVOLSIZE
    TestEject,                              // tEJECT
    TestAudioDisk,                          // tAUDIODISK
    SectorDump,                             // tSECTORDUMP
    TestControl                             // tTESTCONTROL
};

static ReqName mRequests [] = {
    0,0,"INIT: ",                           // rINIT
    3,0,"IOCTLI: Raddr: ",                  // rIRADDR
    3,1,"IOCTLI: LocHead: ",                // rILOCHEAD
    3,3,"IOCTLI: ErrStat: ",                // rIERRSTAT
    3,4,"IOCTLI: AudInfo: ",                // rIAUDINFO
    3,5,"IOCTLI: DrvBytes: ",               // rIDRVBYTES
    3,6,"IOCTLI: DevStat: ",                // rIDEVSTAT
    3,7,"IOCTLI: SectSize: ",               // rISECTSIZE
    3,8,"IOCTLI: VolSize: ",                // rIVOLSIZE
    3,9,"IOCTLI: MedChng: ",               // rIMEDCHNG
    3,10,"IOCTLI: DiskInfo: ",              // rIDISKINFO
    3,11,"IOCTLI: TnoInfo: ",               // rITNOINFO
    3,12,"IOCTLI: QInfo: ",                 // rIQINFO
    3,13,"IOCTLI: SubChanInfo: ",           // rISUBINFO
    3,14,"IOCTLI: UPCCode: ",               // rIUPCCODE
    3,15,"IOCTLI: AudStat: ",               // rIAUDSTAT
    12,0,"IOCTLO: Eject: ",                 // rOEJECT
    12,1,"IOCTLO: LockDoor: ",              // rOLOCKDOOR
    12,2,"IOCTLO: ResetDrv: ",              // rORESET
    12,3,"IOCTLO: AudInfo: ",               // rOAUDINFO
    12,4,"IOCTLO: DrvBytes: ",              // rODRVBYTES
    12,5,"IOCTLO: CloseTray: ",             // rOCLOSETRAY
    0,128,"ReadL: ",                        // rREADL
    0,130,"ReadLPre: ",                     // rREADLPRE
    0,131,"Seek: ",                         // rSEEK
    0,132,"PlayReq: ",                      // rPLAY
    0,133,"StopPlayReq: ",                  // rSTOP
    0,136,"ResumeReq: ",                    // rRESUME
    0,134,"WriteL: ",                       // rWRITE
    0,135,"WriteLV: ",                      // rWRITELV
    0,7,"FlushI: ",                         // rFLUSHI
    0,11,"FlushO: ",                        // rFLUSHO
    0,13,"DevOpen: ",                       // rDOPEN
    0,14,"DevClose: ",                      // rDCLOSE
    0,255,"Reserved Command: ",             // rRESERVED
    3,255,"IOCTLI: Reserved Command: ",     // rIRESERVED
    12,255,"IOCTLO: Reserved Command: "     // rORESERVED
};

