/*
** TESTDRV - CD-ROM device driver test suite
**
** proto.h - function prototypes
**
** HISTORY:
**    10/01/90 Final (v1.0) -by- JYG
*/

#ifdef PREPARE

// prepare.c
 
extern void SectorToArc( Dev_List *drv,DWORD lSector,BYTE bAddrMode,
    BYTE bReadMode, FILE *pOutFile );
extern void prepData( Dev_List *drv );
#endif

// request.c

#include"request.h"

// setup.c

extern void setup( FILE *pInFile );
extern void ChkRepeat(FLAG cdflag);
extern void syntaxError(char * msg);
extern short lookup(char * szLabel);
extern char *getNextLine( char  *pchBuf,FILE *pInFile);
extern char getBool(char * pchSrc);
extern char *getNextString(char *pchDest,char *pchSrc,char *pchDelim);

// support.c

extern void fatalError(char *msg );
extern WORD InterpStatus(WORD wStatus );
extern char Ask(char *chQuestion );
extern void Msg( ReqName sLabel,char *szStat,char *szMsg );
extern void ErrMsg( ReqName sLabel,char *szSt );
extern void WarningMsg( ReqName sLabel,char *szSt );
extern void ReportMsg( ReqName sLabel,char *szSt );
extern WORD ErrorTest(WORD wStatus, ReqName sLabel );
extern void PrintAudInfo( AudInfo_Rec ainf );
extern void HexDump(BYTE _far *pchBuf,WORD nbytes );
extern BYTE _far *my_malloc(DWORD how_much );
extern void my_free(BYTE _far *buffer );
extern void PrintRed(DWORD lSector );
extern DWORD RedDiff(DWORD lSectorA,DWORD lSectorB );
extern BYTE bcd2bin(BYTE c );
extern DWORD red2hsg(DWORD l );
extern DWORD hsg2red(DWORD l );
extern void find_drivers( Dev_List *Dev_Tbl );
extern char * VolLabel( WORD iDrive, char * szName );

// tests.c

extern void TestReservedCmd( Dev_List *drv );
extern void TestDrvBytes( Dev_List *drv );
extern void TestSectorSize( Dev_List *drv );
extern void TestAudioCtrl( Dev_List *drv );
extern void TestSeek( Dev_List *drv,DWORD lSector,BYTE bAddrMode );
extern void TestUPCCode( Dev_List *drv );
extern void TestVolSize( Dev_List *drv );
extern void TestAudioDisk( Dev_List *drv );
extern void TestEject( Dev_List *drv );
extern WORD TestRead( Dev_List *drv,DWORD lSector,BYTE bAddrMode,
    BYTE bReadMode,BYTE _far *pInBuf );
extern void TestControl( Dev_List *drv );
extern void SectorDump( Dev_List *drv );
extern void TestInit( Dev_List *drv );
extern void TestDevStat( Dev_List *drv );
extern void TestRaddr( Dev_List *drv );
extern void TestReset( Dev_List *drv );
extern void TestLockDoor( Dev_List *drv );
extern void TestSubInfo( Dev_List *drv, DWORD dwAddr, DWORD dwNum );

// testdrv.c

extern void testdrv( Dev_List *drv );
extern void main(int argc,char * *argv );
